/**
 *
 * @param {*} message 提示信息内容
 * @param {*} type 状态：success(成功)、warning(警告)、error(错误)
 * @param {*} time 什么时候关闭 倒计时
 */
const MessageHandle = (params) => {
  const { message, type, time } = params;

  const bodyElement = document.body; // 获取body元素

  // 获取页面是否有default-message节点
  const messageList = [];

  if (document.getElementsByClassName("default-message").length) {
    for (
      let i = 0;
      i < document.getElementsByClassName("default-message").length;
      i++
    ) {
      messageList.push(document.getElementsByClassName("default-message")[i]);
    }
  }

  const messageLength = messageList.length;

  let messageDemo = document.createElement("div"); // 创建消息标签
  messageDemo.className = "default-message animated fadeInUp"; // 给父级标签添加class属性
  messageDemo.style.zIndex = `${2000 + messageLength}`; // 动态设置层级
  if (messageLength) {
    messageList.forEach((item) => {
      item.style.top = `${item.offsetTop - item.offsetHeight - 20}px`;
    });
  }
  messageDemo.style.top = `50%`;

  // 创建icon
  let icon = document.createElement("i");
  if (type === "success") {
    icon.className = `default-icon el-icon-success default-message-${type}`;
  } else if (type === "warning") {
    icon.className = `default-icon el-icon-warning default-message-${type}`;
  } else if (type === "error") {
    icon.className = `default-icon el-icon-error default-message-${type}`;
  } else {
    icon.className = `default-icon el-icon-info default-message-${type}`;
  }
  // 将icon插入父级元素
  messageDemo.appendChild(icon);

  // 创建正文内容
  let messageText = document.createElement("div");
  messageText.className = "default-message-content";
  messageText.innerHTML = message;
  messageDemo.appendChild(messageText);

  bodyElement.appendChild(messageDemo); // 将弹框插入到body元素中

  // 定时器
  setTimeout(() => {
    bodyElement.removeChild(
      document.getElementsByClassName("default-message")[0]
    );
  }, time || 3000);
};

export default MessageHandle;
