// 导入按钮组件
import whButton from "./button";
// 导入文件上传组件
// import whUpload from "./upload";
// 导入富文本编译器组件
// import whUeditor from "./ueditor";
import whAlert from "./alert";
import whProgress from "./progress";
import whMessageHandle from "./alert-default";

// 存储组件列表
const components = [whButton, whAlert, whProgress];

// 定义 install 方法，接收 Vue 作为参数。如果使用 use 注册插件，则所有的组件都将被注册
const install = function (Vue) {
  // 判断是否可以安装
  if (install.installed) return;
  // 遍历注册全局组件
  components.map((component) => Vue.component(component.name, component));

  Vue.config.globalProperties.$whMessage = whMessageHandle;
};

// 判断是否是直接引入文件
if (typeof window !== "undefined" && window.Vue) {
  install(window.Vue);
}

export default {
  // 导出的对象必须具有 install，才能被 Vue.use() 方法安装
  install,
  // 以下是具体的组件列表
  whButton,
  whAlert,
  whProgress,
};
